"use strict";

exports.__esModule = true;
exports.default = void 0;

var _host = _interopRequireDefault(require("./host"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function instantiateComponent(element) {
  var instance;

  if (element === undefined || element === null || element === false || element === true) {
    instance = new _host.default.EmptyComponent();
  } else if (Array.isArray(element)) {
    instance = new _host.default.FragmentComponent(element);
  } else if (typeof element === 'object' && element.type) {
    // Special case string values
    if (typeof element.type === 'string') {
      instance = new _host.default.NativeComponent(element);
    } else {
      instance = new _host.default.CompositeComponent(element);
    }
  } else if (typeof element === 'string' || typeof element === 'number') {
    instance = new _host.default.TextComponent(element);
  } else {
    throw new Error("Invalid element type: " + element + ". (current: " + (typeof element === 'object' && Object.keys(element) || typeof element) + ")");
  }

  instance._mountIndex = 0;
  return instance;
}

var _default = instantiateComponent;
exports.default = _default;